<!DOCTYPE html>
<html>

<head>
    <meta charset='utf-8'>
    <meta name='viewport' content='width=device-width, initial-scale=1'>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script> 
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>    
</head>
 
<script>
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    function onBtnGetNewDiceClick() {
        //base url
        const vBASE_URL = "http://203.171.20.210:8080/devcamp-lucky-dice/";
        const vUTF8_TEXT_APPLICATION_HEADER = "application/json;charset=UTF-8";
        // data to be sent by post method
        var vDataObject = {
            firstname: "do",
            lastname: "nga",
            username: "ngado20"
        }

        // create a request
        var vXmlHttpDice = new XMLHttpRequest();
        vXmlHttpDice.open("POST", vBASE_URL + "/dice", true);
        vXmlHttpDice.setRequestHeader("Content-Type", vUTF8_TEXT_APPLICATION_HEADER);
        vXmlHttpDice.send(JSON.stringify(vDataObject));  //chuyển Json object sang string

        vXmlHttpDice.onreadystatechange = function () {
            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {  //nếu trạng thái của response ready và ok
                //hãy REFACTORING ĐẨY MÃ NGUỒN XỬ LÝ RA FUNCTION KHÁC
                console.log(vXmlHttpDice.responseText);
                // parsing to object
                var vResponse = JSON.parse(vXmlHttpDice.responseText);
                // get result dice
                var vDiceReady = vResponse.dice;
                console.log("dice result:= " + vDiceReady);
            }
        }

    }

    //gọi mẫu lấy prize history
    function onBtnPrizeHistoryClick() {
        //base url
        const vBASE_URL = "http://203.171.20.210:8080/devcamp-lucky-dice";
        var vUserNameTest = "ngado20";
        // create a request
        var vXmlHtt0pPrizeHistory = new XMLHttpRequest();
        vXmlHtt0pPrizeHistory.open("GET", vBASE_URL + "/prize-history?username=" + vUserNameTest, true);
        vXmlHtt0pPrizeHistory.send();
        vXmlHtt0pPrizeHistory.onreadystatechange =
            function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    var vPrizeHistory = vXmlHtt0pPrizeHistory.responseText;
                    console.log(vPrizeHistory);
                }
            }

    }

    //gọi mẫu lấy voucher history
    function onBtnClickVoucherHistoryClick() {
        //base url
        const vBASE_URL = "http://203.171.20.210:8080/devcamp-lucky-dice";
        var vUserNameTest = "ngado20";
        var vXmlHttpVoucherHistory = new XMLHttpRequest();
        vXmlHttpVoucherHistory.open("GET", vBASE_URL + "/voucher-history?username=" + vUserNameTest, true);
        vXmlHttpVoucherHistory.send();
        vXmlHttpVoucherHistory.onreadystatechange =
            function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    var vVoucherHistory = vXmlHttpVoucherHistory.responseText;
                    console.log(vVoucherHistory);
                }
            }
    }

    //gọi mẫu lấy dic history
    function onBtnClickDiceHistoryClick() {
        //base url
        const vBASE_URL = "http://203.171.20.210:8080/devcamp-lucky-dice";
        var vUserNameTest = "ngado20";

        var vXmlHttpDiceHistory = new XMLHttpRequest();
        vXmlHttpDiceHistory.open("GET", vBASE_URL + "/dice-history?username=" + vUserNameTest, true);
        vXmlHttpDiceHistory.send();
        vXmlHttpDiceHistory.onreadystatechange =
            function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    console.log(vXmlHttpDiceHistory.responseText);
                }
            }
    }

</script>

<body class="bg-light">
    <div class="container">
        <div class="form-group">
            <p id="cmt2dev">Test Page for Javascrip Tasks. F5 to run code. </p>
        </div>
        <div class="form-group"> 
                <input type="button" class="btn btn-info" onclick="onBtnGetNewDiceClick()" value="Call post api get new dice!">
                <input type="button" class="btn btn-danger" onclick="onBtnPrizeHistoryClick()" value="Call get api prize history!">
                <input type="button" class="btn btn-primary" onclick="onBtnClickVoucherHistoryClick()" value="Call get api voucher history!">
                <input type="button" class="btn btn-success" onclick="onBtnClickDiceHistoryClick()" value="Call get api dice history!"> 
        </div>
        <div class="form-group">
            <ul>
                <li>api get new dice: lấy new dice, voucher, prize </li>
                <li>get api prize history: lấy lịch sử prize (phần thưởng) của user</li>
                <li>get api voucher history: lấy lịch sử voucher của user </li>
                <li>get api dice history: lấy lịch sử dice của user</li>
            </ul>
            <p id="testP" style="font-size:larger;">Demo gọi 01 post API!</p>
            <p> Input: username, firstname, lastname</p>
        </div>
    </div>
</body>

</html>